// ajax.js
//

if (document.getElementById == 'undefined') {
    document.prototype.getElementById = function(id) {
        var result;

        result = null;

        try {
            result = document.all[id];
        }
        catch (error) {
            throw "Method getElementById is not implemented and can't be proxied.";
        }

        return result;
    }
}

var Options = {
    Init: function() { 
        this.PageIcon = document.getElementById('page-icon');
        this.PageLink = document.getElementById('page-link');
        this.DiscussionIcon = document.getElementById('discussion-icon');
        this.DiscussionLink = document.getElementById('discussion-link');

        // Create status indicators
        //
        CreatePageStatus();
        CreateDiscussionStatus();
 
        // Start updates
        // 
        setTimeout('UpdatePageStatus();', 1);
    }
};

var CreatePageStatus = function() {
    var host;
    var path;
    var baseURI;
    var pageLinkText;

    host = 'http://docs.webworks.com'
    path = document.location.href.split('?')[1];
    baseURI = host + path;

    // Lookup page status
    //
    Options.pageLinkAnchor = document.createElement('a');
    Options.pageLinkAnchor.setAttribute('href', baseURI)
    Options.pageLinkAnchor.setAttribute('target', 'wiki_page');
    pageLinkText = document.createTextNode('Wiki');
    Options.pageLinkAnchor.appendChild(pageLinkText);

    Options.PageLink.appendChild(Options.pageLinkAnchor);
}

var UpdatePageStatus = function() {
    var host;
    var path;
    var baseURI;
    var ajax;

    host = 'http://docs.webworks.com'
    path = document.location.href.split('?')[1];
    baseURI = host + path;

    // Lookup page status
    //
    ajax = GetAjaxRequest();

    ajax.open('HEAD', path + '?action=raw&rev=2', true);

    ajax.onreadystatechange = function() {
        if (ajax.readyState == 4) {
            if (ajax.status == 200) {
                var pageLinkAnchorHref;
          
                pageLinkAnchorHref = baseURI + '?action=diff&rev1=1';
                Options.pageLinkAnchor.setAttribute('href', pageLinkAnchorHref);
                Options.PageIcon.src = 'status_changed.gif';
            }
            else {
                Options.PageIcon.src = 'status_unchanged.gif';
            }

            // Clean up
            //
            delete ajax;
            ajax = null;

            // Continue updates
            //
            setTimeout('UpdateDiscussionStatus();', 1);
        }
    };

    ajax.send('');
};

var CreateDiscussionStatus = function() {
    var host;
    var path;
    var baseURI;
    var discussionLinkText;

    host = 'http://docs.webworks.com'
    path = document.location.href.split('?')[1];
    baseURI = host + path;

    // Initiate lookup of discussion status
    //
    Options.discussionLinkAnchor = document.createElement('a');
    Options.discussionLinkAnchor.setAttribute('target', 'wiki_discussion');
    Options.discussionLinkAnchor.setAttribute('href', baseURI + '?action=supplementation');
    discussionLinkText = document.createTextNode('Discussion');
    Options.discussionLinkAnchor.appendChild(discussionLinkText);
 
    Options.DiscussionLink.appendChild(Options.discussionLinkAnchor);

}

var UpdateDiscussionStatus = function() {
    var host;
    var path;
    var baseURI;
    var ajax;

    host = 'http://docs.webworks.com'
    path = document.location.href.split('?')[1];
    baseURI = host + path;

    // Lookup page status
    //
    ajax = GetAjaxRequest();

    ajax.open('HEAD', path + '/Discussion?action=raw', true);

    ajax.onreadystatechange = function() {
        if (ajax.readyState == 4) {
            if (ajax.status == 200) {
                Options.DiscussionIcon.src = 'status_changed.gif';
            }
            else {
                Options.DiscussionIcon.src = 'status_unchanged.gif';
            }

            // Clean up
            //
            delete ajax;
            ajax = null;
        }
    };

    ajax.send('');
};

var GetAjaxRequest = function() {
    var result;

    result = null;

    try {
        // Firefox, Opera 8.0+, Safari
        //
        result = new XMLHttpRequest();
    }
    catch (e) {
        // Internet Explorer
        //
        try {
            result = new ActiveXObject("Msxml2.XMLHTTP");
        }
        catch (e) {
            //
            //
            result = new ActiveXObject("Microsoft.XMLHTTP");
        }
    }
    
    return result;
};
